clear all;
close all;
A = load('matrix.dat');
x_mod = load('solution.dat');
figure(1)
plotsol( x_mod )
title('Model solution')
%
b = A*x_mod;

pert = input('Perturbation in b = ');
db = randn(size(b));
pert = pert*norm(b)/norm(db);
b = b + pert*db;

[U,S,V] = svd(A,0);
%
figure(2);
semilogy(diag(S),'*');
title('Singular values')
r = 100;
while ( r > 0 ) 
   r = input('Number of singulat values to compute solution (max=200): ')
   if ( r < 1 ) break; end;
   r = min(200,r);
   x_lsmn = soluti( b, U,S,V, r );
   err = norm(x_mod - x_lsmn);
   disp(['Error in solution: ',num2str(err)]);
   figure(3)
   plotsol( x_lsmn )
   title('Least Squares Minimum Norm Solution')
end

return
m_iter = input('Maximum number of iterations: ')
eps = 1.e-6;
figure(4)
[x_it res err] = cgls( A, b, m_iter, eps, x_mod );
title('Iterative solution')

er = norm(x_mod - x_it);
disp(['Error in solution: ',num2str(er)]);

it = [0:1:length(res)-1];
figure(5)
semilogy(it, res)
title('Residual norm')

figure(6)
semilogy(it, err)
title('True error')
%
